package org.apache.bcel.classfile;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.ElementValue;

public class EnumElementValue extends ElementValue {
  private final int typeIdx;
  
  private final int valueIdx;
  
  public EnumElementValue(int type, int typeIdx, int valueIdx, ConstantPool cpool) {
    super(type, cpool);
    if (type != 101)
      throw new IllegalArgumentException("Only element values of type enum can be built with this ctor - type specified: " + type); 
    this.typeIdx = typeIdx;
    this.valueIdx = valueIdx;
  }
  
  public void dump(DataOutputStream dos) throws IOException {
    dos.writeByte(getType());
    dos.writeShort(this.typeIdx);
    dos.writeShort(this.valueIdx);
  }
  
  public String getEnumTypeString() {
    return getConstantPool().getConstantUtf8(this.typeIdx).getBytes();
  }
  
  public String getEnumValueString() {
    return getConstantPool().getConstantUtf8(this.valueIdx).getBytes();
  }
  
  public int getTypeIndex() {
    return this.typeIdx;
  }
  
  public int getValueIndex() {
    return this.valueIdx;
  }
  
  public String stringifyValue() {
    return getConstantPool().getConstantUtf8(this.valueIdx).getBytes();
  }
}
